# ApplicationFramework
TKLCAF
TDataStd

# TDataStd_ExtStringArray Class Reference

ExtStringArray Attribute. Handles an
array of UNICODE strings (represented by the
TCollection_ExtendedString class).
.

`#include <TDataStd_ExtStringArray.hxx>`

Inheritance diagram for TDataStd_ExtStringArray:

[legend]

## Public Member Functions

Standard_EXPORT void | Init (const Standard_Integer lower, const Standard_Integer upper)
| Initializes the inner array with bounds from <lower> to <upper> .
Standard_EXPORT void | SetValue (const Standard_Integer Index, const TCollection_ExtendedString &Value)
| Sets the <index>th element of the array to <value> .
Standard_EXPORT TCollection_ExtendedString | Value (const Standard_Integer Index) const
| Returns the value of the <index>th element of the array .
TCollection_ExtendedString | operator() (const Standard_Integer Index) const
Standard_EXPORT Standard_Integer | Lower () const
| Return the lower bound. .
Standard_EXPORT Standard_Integer | Upper () const
| Return the upper bound .
Standard_EXPORT Standard_Integer | Length () const
| Return the number of elements of <me>. .
Standard_EXPORT void | ChangeArray (const Handle(TColStd_HArray1OfExtendedString)&newArray, const Standard_Boolean isCheckItems=Standard_True)
| Sets the inner array <myvalue> of the ExtStringArray attribute to <newarray>. If value of <newarray> differs from <myvalue>, Backup performed and myValue refers to new instance of HArray1OfExtendedString that holds <newarray> values If <ischeckitems> equal True each item of <newarray> will be checked with each item of <myvalue> for coincidence (to avoid backup). .
const Handle_TColStd_HArray1OfExtendedString | Array () const
| Return the inner array of the ExtStringArray attribute .
Standard_Boolean | GetDelta () const
void | SetDelta (const Standard_Boolean isDelta)
| for internal use only!
Standard_EXPORT | TDataStd_ExtStringArray ()
Standard_EXPORT const Standard_GUID & | ID () const
| Returns the ID of the attribute. .
Standard_EXPORT void | Restore (const Handle(TDF_Attribute)&With)
| Restores the backuped contents from <anattribute> into this one. It is used when aborting a transaction. .
Standard_EXPORT Handle_TDF_Attribute | NewEmpty () const
| Returns an new empty attribute from the good end type. It is used by the copy algorithm. .
Standard_EXPORT void | Paste (const Handle(TDF_Attribute)&Into, const Handle(TDF_RelocationTable)&RT) const

This method is different from the "Copy" one,
because it is used when copying an attribute from
a source structure into a target structure. This
method may paste the contents of <me> into
<intoattribute>.
The given pasted attribute can be full or empty of
its contents. But don't make a NEW! Just set the
contents!
It is possible to use <arelocationtable> to
get/set the relocation value of a source
attribute.
.

virtual Standard_EXPORT Standard_OStream & | Dump (Standard_OStream &anOS) const
| Dumps the minimum information about <me> on <astream>. .
virtual Standard_EXPORT Handle_TDF_DeltaOnModification | DeltaOnModification (const Handle(TDF_Attribute)&anOldAttribute) const
| Makes a DeltaOnModification between <me> and <anoldattribute>. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT const Standard_GUID & | GetID ()
| class methods ============= //! Returns the GUID for the attribute.
static Standard_EXPORT Handle_TDataStd_ExtStringArray | Set (const TDF_Label &label, const Standard_Integer lower, const Standard_Integer upper, const Standard_Boolean isDelta=Standard_False)
| Finds, or creates, an ExtStringArray attribute with <lower> and <upper> bounds. The ExtStringArray attribute is returned. If <isdelta> == False, DefaultDeltaOnModification is used. If attribute is already set, all input parameters are refused and the found attribute is returned. .

## Private Member Functions

void | RemoveArray ()

## Private Attributes

Handle_TColStd_HArray1OfExtendedString | myValue
Standard_Boolean | myIsDelta

## Constructor & Destructor Documentation

Standard_EXPORT TDataStd_ExtStringArray::TDataStd_ExtStringArray | ( |  | ) |

## Member Function Documentation

const Handle_TColStd_HArray1OfExtendedString TDataStd_ExtStringArray::Array | ( |  | ) | const

Standard_EXPORT void TDataStd_ExtStringArray::ChangeArray | ( | const Handle(TColStd_HArray1OfExtendedString)& | newArray,
|  | const Standard_Boolean | isCheckItems = `Standard_True`
| ) |

virtual Standard_EXPORT Handle_TDF_DeltaOnModification TDataStd_ExtStringArray::DeltaOnModification | ( | const Handle(TDF_Attribute)& | anOldAttribute | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

virtual Standard_EXPORT Standard_OStream& TDataStd_ExtStringArray::Dump | ( | Standard_OStream & | anOS | ) | const`[virtual]`

| Reimplemented from TDF_Attribute.

Standard_Boolean TDataStd_ExtStringArray::GetDelta | ( |  | ) | const`[inline]`

static Standard_EXPORT const Standard_GUID& TDataStd_ExtStringArray::GetID | ( |  | ) | `[static]`

Standard_EXPORT const TDataStd_ExtStringArray::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from TDF_Attribute.

Standard_EXPORT const Standard_GUID& TDataStd_ExtStringArray::ID | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

Standard_EXPORT void TDataStd_ExtStringArray::Init | ( | const Standard_Integer | lower,
|  | const Standard_Integer | upper
| ) |

Standard_EXPORT Standard_Integer TDataStd_ExtStringArray::Length | ( |  | ) | const

Standard_EXPORT Standard_Integer TDataStd_ExtStringArray::Lower | ( |  | ) | const

Standard_EXPORT Handle_TDF_Attribute TDataStd_ExtStringArray::NewEmpty | ( |  | ) | const`[virtual]`

| Implements TDF_Attribute.

TCollection_ExtendedString TDataStd_ExtStringArray::operator() | ( | const Standard_Integer | Index | ) | const`[inline]`

Standard_EXPORT void TDataStd_ExtStringArray::Paste | ( | const Handle(TDF_Attribute)& | Into,
|  | const Handle(TDF_RelocationTable)& | RT
| ) | const`[virtual]`

| Implements TDF_Attribute.

void TDataStd_ExtStringArray::RemoveArray | ( |  | ) | `[inline, private]`

Standard_EXPORT void TDataStd_ExtStringArray::Restore | ( | const Handle(TDF_Attribute)& | With | ) | `[virtual]`

| Implements TDF_Attribute.

static Standard_EXPORT Handle_TDataStd_ExtStringArray TDataStd_ExtStringArray::Set | ( | const TDF_Label & | label,
|  | const Standard_Integer | lower,
|  | const Standard_Integer | upper,
|  | const Standard_Boolean | isDelta = `Standard_False`
| ) | `[static]`

void TDataStd_ExtStringArray::SetDelta | ( | const Standard_Boolean | isDelta | ) | `[inline]`

Standard_EXPORT void TDataStd_ExtStringArray::SetValue | ( | const Standard_Integer | Index,
|  | const TCollection_ExtendedString & | Value
| ) |

Standard_EXPORT Standard_Integer TDataStd_ExtStringArray::Upper | ( |  | ) | const

Standard_EXPORT TCollection_ExtendedString TDataStd_ExtStringArray::Value | ( | const Standard_Integer | Index | ) | const

## Field Documentation

Standard_Boolean TDataStd_ExtStringArray::myIsDelta `[private]`

Handle_TColStd_HArray1OfExtendedString TDataStd_ExtStringArray::myValue `[private]`

The documentation for this class was generated from the following files:

- TDataStd_ExtStringArray.hxx
- TDataStd_ExtStringArray.lxx